/* MED-newintui.c ---- Intuition-structures from V2.00 */
#include "med.h"
extern struct Kappale far tamakappale;

extern UWORD chip gfximg2[],chip gfximg3[],chip gfximg4[],chip gfximg5[];
extern UWORD chip gfximg6[],chip gfximg7[],chip gfximg9[],chip gfximgA[];
extern UWORD chip okt12data[],chip okt23data[],chip okt34data[];
extern UWORD chip okt45data[],chip loadgadgets[],chip savegadgets[];

struct Image autoknobimg[8];
struct Image far kuviot = { 0,0,224,45,2,gfximg2,0x3,0x0,NULL };
struct Image far loadgadgimg = { 0,0,66,14,2,loadgadgets,0x3,0x0,NULL };
struct Image far savegadgimg = { 0,0,66,14,2,savegadgets,0x3,0x0,NULL };
struct Image far oktimg[5] = { { 0,0,13,8,2,okt12data,0x3,0x0,NULL },
{ 0,0,13,8,2,okt23data,0x3,0x0,NULL },{ 0,0,13,8,2,okt34data,0x3,0x0,NULL },
{ 0,0,13,8,2,okt45data,0x3,0x0,NULL } };
char hakemisto[100],kappaleennimi[50],undo[100],toistostr[7],tpitstr[7];
char presetstr[8];
UWORD *imgdataptr[] = {
	NULL,NULL,gfximg2,gfximg3,gfximg4,gfximg5,gfximg6,gfximg7,
	NULL,gfximg9,gfximgA };

struct PropInfo propinfo[] = {
{ AUTOKNOB|FREEVERT|PROPBORDERLESS,MAXPOT,MAXPOT,MAXBODY,MAXBODY,0,0,0,0,0,0 },
{ AUTOKNOB|FREEHORIZ|PROPBORDERLESS,0x2134,MAXPOT,0x112,MAXBODY,0,0,0,0,0,0 },
{ AUTOKNOB|FREEHORIZ|PROPBORDERLESS,MAXPOT,MAXPOT,0x400,MAXBODY,0,0,0,0,0,0 },
{ AUTOKNOB|FREEHORIZ|PROPBORDERLESS,MAXPOT,MAXPOT,508,MAXBODY,0,0,0,0,0,0 },
{ AUTOKNOB|FREEHORIZ|PROPBORDERLESS,MAXPOT/2,MAXPOT,2621,MAXBODY,0,0,0,0,0,0 },
{ AUTOKNOB|FREEHORIZ|PROPBORDERLESS,0,0,MAXBODY/16,MAXBODY,0,0,0,0,0,0 },
{ AUTOKNOB|FREEHORIZ|PROPBORDERLESS,0,0,MAXBODY/16,MAXBODY,0,0,0,0,0,0 },
{ AUTOKNOB|FREEHORIZ|PROPBORDERLESS,0,0,MAXBODY/16,MAXBODY,0,0,0,0,0,0 }
};
struct StringInfo strinfo[] = {
{ hakemisto,undo,0,100,0,0,0,0,0,0,NULL,NULL,NULL },
{ kappaleennimi,undo,0,50,0,0,0,0,0,0,NULL,NULL,NULL },
{ &tamakappale.soitin[1][0],undo,0,40,0,0,0,0,0,0,NULL,NULL,NULL },
{ toistostr,undo,0,7,0,0,0,0,0,0,NULL,NULL,NULL },
{ tpitstr,undo,0,7,0,0,0,0,0,0,NULL,NULL,NULL },
{ presetstr,undo,0,4,0,0,0,0,0,0,NULL,NULL,NULL }
};
struct Gadget far gadget1[] = {
{ &gadget1[1],233,17,39,7,GADGHNONE,GADGIMMEDIATE,BOOLGADGET,NULL,NULL,
  NULL,NULL,NULL,0x102,NULL },
{ &gadget1[2],233,27,39,7,GADGHNONE,GADGIMMEDIATE,BOOLGADGET,NULL,NULL,
  NULL,NULL,NULL,0x103,NULL },
{ &gadget1[3],233,37,39,7,GADGHNONE,GADGIMMEDIATE,BOOLGADGET,NULL,NULL,
  NULL,NULL,NULL,0x104,NULL },
{ &gadget1[4],233,47,39,7,GADGHNONE,GADGIMMEDIATE,BOOLGADGET,NULL,NULL,
  NULL,NULL,NULL,0x105,NULL },
{ &gadget1[5],233,57,39,7,GADGHNONE,GADGIMMEDIATE,BOOLGADGET,NULL,NULL,
  NULL,NULL,NULL,0x106,NULL },
{ &gadget1[6],276,17,39,7,GADGHNONE,GADGIMMEDIATE,BOOLGADGET,NULL,NULL,
  NULL,NULL,NULL,0x107,NULL },
{ &gadget1[7],276,37,39,7,GADGHNONE,GADGIMMEDIATE,BOOLGADGET,NULL,NULL,
  NULL,NULL,NULL,0x109,NULL },
{ &gadget1[8],276,47,39,7,GADGHNONE,GADGIMMEDIATE,BOOLGADGET,NULL,NULL,
  NULL,NULL,NULL,0x10A,NULL },
{ &gadget1[9],179,66,5,8,GADGHNONE,GADGIMMEDIATE,BOOLGADGET,NULL,NULL,
  NULL,NULL,NULL,0xF00,NULL },	/* Editoi (E) */
{ &gadget1[10],186,66,9,8,GADGHNONE,GADGIMMEDIATE,BOOLGADGET,NULL,NULL,
  NULL,NULL,NULL,0xF01,NULL },	/* 2 */
{ NULL,164,66,13,8,GADGHNONE,GADGIMMEDIATE,BOOLGADGET,NULL,NULL,
  NULL,NULL,NULL,0xF02,NULL }	/* 1+2/2+3/3+4/4+5/5+6 */
};

struct Gadget far gadget2[] = {
{ &gadget2[1],8,21,120,8,GADGHCOMP,RELVERIFY,BOOLGADGET,NULL,NULL,
  NULL,NULL,NULL,0x200,NULL }, /* rivi1 */
{ &gadget2[2],8,29,120,8,GADGHCOMP,RELVERIFY,BOOLGADGET,NULL,NULL,
  NULL,NULL,NULL,0x201,NULL },
{ &gadget2[3],8,37,120,8,GADGHCOMP,RELVERIFY,BOOLGADGET,NULL,NULL,
  NULL,NULL,NULL,0x202,NULL },
{ &gadget2[4],8,45,120,8,GADGHCOMP,RELVERIFY,BOOLGADGET,NULL,NULL,
  NULL,NULL,NULL,0x203,NULL },
{ &gadget2[5],8,53,120,8,GADGHCOMP,RELVERIFY,BOOLGADGET,NULL,NULL,
  NULL,NULL,NULL,0x204,NULL }, /* rivi5 */
{ &gadget2[6],130,21,6,6,GADGHNONE,GADGIMMEDIATE,BOOLGADGET,NULL,NULL,
  NULL,NULL,NULL,0x205,NULL }, /* nuoli yls */
{ &gadget2[7],130,29,6,24,GADGHCOMP|GADGIMAGE,RELVERIFY,PROPGADGET,/*selaus*/
  (APTR)&autoknobimg[0],NULL,NULL,NULL,(APTR)&propinfo[0],0x206,NULL },
{ &gadget2[8],130,55,6,6,GADGHNONE,GADGIMMEDIATE,BOOLGADGET,NULL,NULL,
  NULL,NULL,NULL,0x207,NULL }, /* nuoli alas */
{ &gadget2[9],153,43,74,8,GADGHCOMP,RELVERIFY,STRGADGET,NULL,NULL,
  NULL,NULL,(APTR)&strinfo[0],0x208,NULL }, /* Hak. nimi */
{ &gadget2[10],153,53,74,8,GADGHCOMP,RELVERIFY,STRGADGET,NULL,NULL,
  NULL,NULL,(APTR)&strinfo[1],0x209,NULL }, /* Kpl nimi */
{ &gadget2[11],139,20,21,5,GADGHNONE,GADGIMMEDIATE,BOOLGADGET,NULL,NULL,
  NULL,NULL,NULL,0x120A,NULL }, /* Lataa */
{ &gadget2[12],139,27,21,5,GADGHNONE,GADGIMMEDIATE,BOOLGADGET,NULL,NULL,
  NULL,NULL,NULL,0x20B,NULL }, /* Tall. */
{ &gadget2[13],139,34,16,7,GADGHNONE,GADGIMMEDIATE,BOOLGADGET,NULL,NULL,
  NULL,NULL,NULL,0x20F,NULL }, /* DF0 */
{ &gadget2[14],157,34,16,7,GADGHNONE,GADGIMMEDIATE,BOOLGADGET,NULL,NULL,
  NULL,NULL,NULL,0x210,NULL }, /* DF1 */
{ &gadget2[15],175,34,16,7,GADGHNONE,GADGIMMEDIATE,BOOLGADGET,NULL,NULL,
  NULL,NULL,NULL,0x211,NULL }, /* DF2 */
{ &gadget2[16],193,34,16,7,GADGHNONE,GADGIMMEDIATE,BOOLGADGET,NULL,NULL,
  NULL,NULL,NULL,0x212,NULL }, /* DF3 */
{ &gadget2[17],213,34,16,7,GADGHNONE,GADGIMMEDIATE,BOOLGADGET,NULL,NULL,
  NULL,NULL,NULL,0x213,NULL }, /* DH0 */
/* Gadget 17: Lataus */
{ &gadget2[18],163,20,64,5,GADGHNONE,GADGIMMEDIATE,BOOLGADGET,NULL,NULL,
  NULL,NULL,NULL,0x214,NULL },	/* Lataa kappale */
{ &gadget2[19],163,27,31,5,GADGHNONE,GADGIMMEDIATE,BOOLGADGET,NULL,NULL,
  NULL,NULL,NULL,0x215,NULL },	/* Lataa soitin */
{ NULL,196,27,31,5,GADGHNONE,GADGIMMEDIATE,BOOLGADGET,NULL,NULL,
  NULL,NULL,NULL,0x216,NULL },	/* ST MOD */
/* Gadget 20: Tallennus */
{ &gadget2[21],163,20,31,5,GADGHNONE,GADGIMMEDIATE,BOOLGADGET,NULL,NULL,
  NULL,NULL,NULL,0x217,NULL },	/* Tall. kpl */
{ &gadget2[22],163,27,31,5,GADGHNONE,GADGIMMEDIATE,BOOLGADGET,NULL,NULL,
  NULL,NULL,NULL,0x218,NULL },	/* Tall. soitin */
{ &gadget2[23],196,20,14,5,GADGHNONE,GADGIMMEDIATE,BOOLGADGET,NULL,NULL,
  NULL,NULL,NULL,0x219,NULL },	/* ST */
{ &gadget2[24],196,27,14,5,GADGHNONE,GADGIMMEDIATE,BOOLGADGET,NULL,NULL,
  NULL,NULL,NULL,0x21A,NULL },	/* K+S */
{ &gadget2[25],212,20,15,5,GADGHNONE,GADGIMMEDIATE,BOOLGADGET,NULL,NULL,
  NULL,NULL,NULL,0x21B,NULL },	/* Obj */
{ NULL,212,27,15,5,GADGHNONE,GADGIMMEDIATE,BOOLGADGET,NULL,NULL,
  NULL,NULL,NULL,0x121C,NULL }	/* Icon */
};

struct Gadget far gadget3[] = {
{ &gadget3[1],6,19,63,7,GADGHNONE,GADGIMMEDIATE,BOOLGADGET,NULL,NULL,
  NULL,NULL,NULL,0x300,NULL }, /* Soita kappale */
{ &gadget3[2],6,28,63,7,GADGHNONE,GADGIMMEDIATE,BOOLGADGET,NULL,NULL,
  NULL,NULL,NULL,0x301,NULL }, /* Soita lohkoa */
{ &gadget3[3],6,37,63,7,GADGHNONE,GADGIMMEDIATE,BOOLGADGET,NULL,NULL,
  NULL,NULL,NULL,0x302,NULL }, /* Lopeta soitto */
{ &gadget3[4],6,46,63,7,GADGHNONE,GADGIMMEDIATE,BOOLGADGET,NULL,NULL,
  NULL,NULL,NULL,0x303,NULL }, /* Jatka kappaletta */
{ &gadget3[5],6,55,63,7,GADGHNONE,GADGIMMEDIATE,BOOLGADGET,NULL,NULL,
  NULL,NULL,NULL,0x304,NULL }, /* Jatka lohkoa */
{ &gadget3[6],72,20,41,7,GADGHNONE,GADGIMMEDIATE,BOOLGADGET,NULL,NULL,
  NULL,NULL,NULL,0x1305,NULL }, /* Suodatin */
{ &gadget3[7],72,29,19,7,GADGHNONE,GADGIMMEDIATE,BOOLGADGET,NULL,NULL,
  NULL,NULL,NULL,0x1306,NULL }, /* Eq 1 */
{ &gadget3[8],156,21,6,7,GADGHNONE,GADGIMMEDIATE,BOOLGADGET,NULL,NULL,
  NULL,NULL,NULL,0x307,NULL }, /* Liuku5 */
{ &gadget3[9],164,21,6,7,GADGHNONE,GADGIMMEDIATE,BOOLGADGET,NULL,NULL,
  NULL,NULL,NULL,0x1308,NULL }, /* Liuku6    vvv-tempo/prop. */
{ &gadget3[10],85,50,131,10,GADGHCOMP|GADGIMAGE,RELVERIFY,PROPGADGET,
  (APTR)&autoknobimg[1],NULL,NULL,NULL,(APTR)&propinfo[1],0x309,NULL },
{ &gadget3[11],75,50,6,10,GADGHNONE,GADGIMMEDIATE,BOOLGADGET,NULL,NULL,
  NULL,NULL,NULL,0x30A,NULL }, /* tempo <- */
{ &gadget3[12],220,50,6,10,GADGHNONE,GADGIMMEDIATE,BOOLGADGET,NULL,NULL,
  NULL,NULL,NULL,0x30B,NULL }, /* tempo -> */
{ &gadget3[13],193,21,10,10,GADGHNONE,GADGIMMEDIATE,BOOLGADGET,NULL,NULL,
  NULL,NULL,NULL,0x30C,NULL }, /* ^ */
{ &gadget3[14],193,33,10,10,GADGHNONE,GADGIMMEDIATE,BOOLGADGET,NULL,NULL,
  NULL,NULL,NULL,0x30D,NULL }, /* v */
{ &gadget3[15],205,21,10,10,GADGHNONE,GADGIMMEDIATE,BOOLGADGET,NULL,NULL,
  NULL,NULL,NULL,0x30E,NULL }, /* eka */
{ &gadget3[16],205,33,10,10,GADGHNONE,GADGIMMEDIATE,BOOLGADGET,NULL,NULL,
  NULL,NULL,NULL,0x30F,NULL }, /* viim. */
{ &gadget3[17],217,21,10,10,GADGHNONE,GADGIMMEDIATE,BOOLGADGET,NULL,NULL,
  NULL,NULL,NULL,0x310,NULL }, /* + */
{ &gadget3[18],217,33,10,10,GADGHNONE,GADGIMMEDIATE,BOOLGADGET,NULL,NULL,
  NULL,NULL,NULL,0x311,NULL }, /* - */
{ &gadget3[19],135,33,10,10,GADGHNONE,GADGIMMEDIATE,BOOLGADGET,NULL,NULL,
  NULL,NULL,NULL,0x312,NULL }, /* Lis jrj. */
{ &gadget3[20],148,33,10,10,GADGHNONE,GADGIMMEDIATE,BOOLGADGET,NULL,NULL,
  NULL,NULL,NULL,0x313,NULL }, /* Poista jrj. */
{ &gadget3[21],161,33,10,10,GADGHNONE,GADGIMMEDIATE,BOOLGADGET,NULL,NULL,
  NULL,NULL,NULL,0x314,NULL },  /* Lis tm */
{ NULL,93,29,20,7,GADGHNONE,GADGIMMEDIATE,BOOLGADGET,NULL,NULL,
  NULL,NULL,NULL,0x1315,NULL } /* Eq 2 */
};

struct Gadget far gadget4[] = {
{ &gadget4[1],33,20,80,8,GADGHCOMP,RELVERIFY,STRGADGET,NULL,NULL,
  NULL,NULL,(APTR)&strinfo[2],0x400,NULL }, /* Soitin nimi (str) */
{ &gadget4[2],33,30,15,7,GADGHNONE,GADGIMMEDIATE,BOOLGADGET,NULL,NULL,
  NULL,NULL,NULL,0x401,NULL }, /* Ens. soitin */
{ &gadget4[3],98,30,15,7,GADGHNONE,GADGIMMEDIATE,BOOLGADGET,NULL,NULL,
  NULL,NULL,NULL,0x402,NULL }, /* Viim. soitin */
{ &gadget4[4],50,30,22,7,GADGHNONE,GADGIMMEDIATE,BOOLGADGET,NULL,NULL,
  NULL,NULL,NULL,0x403,NULL }, /* << */
{ &gadget4[5],74,30,22,7,GADGHNONE,GADGIMMEDIATE,BOOLGADGET,NULL,NULL,
  NULL,NULL,NULL,0x404,NULL }, /* >> */
{ &gadget4[6],33,39,80,7,GADGHNONE,GADGIMMEDIATE,BOOLGADGET,NULL,NULL,
  NULL,NULL,NULL,0x405,NULL }, /* Lataa soitin */
{ &gadget4[7],7,30,24,7,GADGHNONE,GADGIMMEDIATE,BOOLGADGET,NULL,NULL,
  NULL,NULL,NULL,0x406,NULL }, /* Ukko */
{ &gadget4[8],7,39,24,7,GADGHNONE,GADGIMMEDIATE,BOOLGADGET,NULL,NULL,
  NULL,NULL,NULL,0x407,NULL }, /* Poista */
{ &gadget4[9],179,30,48,8,GADGHCOMP,RELVERIFY|LONGINT,STRGADGET,NULL,NULL,
  NULL,NULL,(APTR)strinfo[3],0x408,NULL }, /* Toisto/alk. */
{ &gadget4[10],179,40,48,8,GADGHCOMP,RELVERIFY|LONGINT,STRGADGET,NULL,NULL,
  NULL,NULL,(APTR)strinfo[4],0x409,NULL }, /* Toisto/pit. */
{&gadget4[11],77,51,6,10,GADGHNONE,GADGIMMEDIATE,BOOLGADGET,NULL,NULL,
  NULL,NULL,NULL,0x40A,NULL }, /* <- voim  vv-voim prop. */
{&gadget4[12],87,51,131,10,GADGHCOMP|GADGIMAGE,RELVERIFY,PROPGADGET,
  (APTR)&autoknobimg[2],NULL,NULL,NULL,(APTR)&propinfo[2],0x40B,NULL },
{NULL,222,51,6,10,GADGHNONE,GADGIMMEDIATE,BOOLGADGET,NULL,NULL,
  NULL,NULL,NULL,0x40C,NULL } /* -> voim */
};

struct Gadget far gadget5[] = {
{ &gadget5[1],66,26,41,10,GADGHNONE,GADGIMMEDIATE,BOOLGADGET,NULL,NULL,
  NULL,NULL,NULL,0x500,NULL }, /* Uusi thn */
{ &gadget5[2],66,38,41,10,GADGHNONE,GADGIMMEDIATE,BOOLGADGET,NULL,NULL,
  NULL,NULL,NULL,0x501,NULL }, /* Tuhoa tm */
{ &gadget5[3],7,50,57,11,GADGHNONE,GADGIMMEDIATE,BOOLGADGET,NULL,NULL,
  NULL,NULL,NULL,0x504,NULL }, /* Uusi lohko */
{ &gadget5[4],66,50,41,11,GADGHNONE,GADGIMMEDIATE,BOOLGADGET,NULL,NULL,
  NULL,NULL,NULL,0x505,NULL }, /* Tuhoa viim. */
{ &gadget5[5],7,38,28,10,GADGHNONE,GADGIMMEDIATE,BOOLGADGET,NULL,NULL,
  NULL,NULL,NULL,0x506,NULL }, /* Ens. */
{ &gadget5[6],37,38,27,10,GADGHNONE,GADGIMMEDIATE,BOOLGADGET,NULL,NULL,
  NULL,NULL,NULL,0x507,NULL }, /* Viim. */
{ &gadget5[7],37,26,27,10,GADGHNONE,GADGIMMEDIATE,BOOLGADGET,NULL,NULL,
  NULL,NULL,NULL,0x508,NULL }, /* Seur. */
{ &gadget5[8],7,26,28,10,GADGHNONE,GADGIMMEDIATE,BOOLGADGET,NULL,NULL,
  NULL,NULL,NULL,0x509,NULL }, /* Ed. */
{ &gadget5[9],109,27,53,7,GADGHNONE,GADGIMMEDIATE,BOOLGADGET,NULL,NULL,
  NULL,NULL,NULL,0x50A,NULL }, /* ni->pusk. */
{ &gadget5[10],109,36,53,7,GADGHNONE,GADGIMMEDIATE,BOOLGADGET,NULL,NULL,
  NULL,NULL,NULL,0x50B,NULL }, /* xxxx->pusk. */
{ &gadget5[11],109,45,53,7,GADGHNONE,GADGIMMEDIATE,BOOLGADGET,NULL,NULL,
  NULL,NULL,NULL,0x50C,NULL }, /* ni<-pusk. */
{ &gadget5[12],109,54,53,7,GADGHNONE,GADGIMMEDIATE,BOOLGADGET,NULL,NULL,
  NULL,NULL,NULL,0x50D,NULL }, /* ni<->pusk. */
{ &gadget5[13],164,27,60,7,GADGHNONE,GADGIMMEDIATE,BOOLGADGET,NULL,NULL,
  NULL,NULL,NULL,0x50E,NULL }, /* lohko->p. */
{ &gadget5[14],164,36,60,7,GADGHNONE,GADGIMMEDIATE,BOOLGADGET,NULL,NULL,
  NULL,NULL,NULL,0x50F,NULL }, /* xxxxx->p. */
{ &gadget5[15],164,45,60,7,GADGHNONE,GADGIMMEDIATE,BOOLGADGET,NULL,NULL,
  NULL,NULL,NULL,0x510,NULL }, /* lohko<-p. */
{ &gadget5[16],164,54,60,7,GADGHNONE,GADGIMMEDIATE,BOOLGADGET,NULL,NULL,
  NULL,NULL,NULL,0x511,NULL }, /* lohko<->p. */
{ &gadget5[17],176,19,8,6,GADGHNONE,GADGIMMEDIATE,BOOLGADGET,NULL,NULL,
  NULL,NULL,NULL,0x1512,NULL },	/* 4 raitaa */
{ &gadget5[18],186,19,8,6,GADGHNONE,GADGIMMEDIATE,BOOLGADGET,NULL,NULL,
  NULL,NULL,NULL,0x513,NULL },	/* 8 raitaa */
{ &gadget5[19],196,19,8,6,GADGHNONE,GADGIMMEDIATE,BOOLGADGET,NULL,NULL,
  NULL,NULL,NULL,0x514,NULL },	/* 12 raitaa */
{ NULL,206,19,8,6,GADGHNONE,GADGIMMEDIATE,BOOLGADGET,NULL,NULL,
  NULL,NULL,NULL,0x515,NULL }	/* 16 raitaa */
};

struct Gadget far gadget6[] = {
{ &gadget6[1],183,36,42,10,GADGHNONE,GADGIMMEDIATE,BOOLGADGET,NULL,NULL,
  NULL,NULL,NULL,0x600,NULL }, /* Editoi */
{ &gadget6[2],183,49,42,10,GADGHNONE,GADGIMMEDIATE,BOOLGADGET,NULL,NULL,
  NULL,NULL,NULL,0x601,NULL }, /* 2vli */
{ &gadget6[3],51,21,9,9,GADGHNONE,GADGIMMEDIATE,BOOLGADGET,NULL,NULL,
  NULL,NULL,NULL,0x1602,NULL },
{ &gadget6[4],62,21,9,9,GADGHNONE,GADGIMMEDIATE,BOOLGADGET,NULL,NULL,
  NULL,NULL,NULL,0x1603,NULL },
{ &gadget6[5],73,21,9,9,GADGHNONE,GADGIMMEDIATE,BOOLGADGET,NULL,NULL,
  NULL,NULL,NULL,0x1604,NULL },
{ &gadget6[6],84,21,9,9,GADGHNONE,GADGIMMEDIATE,BOOLGADGET,NULL,NULL,
  NULL,NULL,NULL,0x1605,NULL },
{ &gadget6[7],95,21,9,9,GADGHNONE,GADGIMMEDIATE,BOOLGADGET,NULL,NULL,
  NULL,NULL,NULL,0x1606,NULL },
{ &gadget6[8],106,21,9,9,GADGHNONE,GADGIMMEDIATE,BOOLGADGET,NULL,NULL,
  NULL,NULL,NULL,0x1607,NULL },
{ &gadget6[9],117,21,9,9,GADGHNONE,GADGIMMEDIATE,BOOLGADGET,NULL,NULL,
  NULL,NULL,NULL,0x1608,NULL },
{ &gadget6[10],128,21,9,9,GADGHNONE,GADGIMMEDIATE,BOOLGADGET,NULL,NULL,
  NULL,NULL,NULL,0x1609,NULL },
{ &gadget6[11],139,21,9,9,GADGHNONE,GADGIMMEDIATE,BOOLGADGET,NULL,NULL,
  NULL,NULL,NULL,0x160A,NULL },
{ &gadget6[12],150,21,9,9,GADGHNONE,GADGIMMEDIATE,BOOLGADGET,NULL,NULL,
  NULL,NULL,NULL,0x160B,NULL },
{ &gadget6[13],161,21,9,9,GADGHNONE,GADGIMMEDIATE,BOOLGADGET,NULL,NULL,
  NULL,NULL,NULL,0x160C,NULL },
{ &gadget6[14],172,21,9,9,GADGHNONE,GADGIMMEDIATE,BOOLGADGET,NULL,NULL,
  NULL,NULL,NULL,0x160D,NULL },
{ &gadget6[15],183,21,9,9,GADGHNONE,GADGIMMEDIATE,BOOLGADGET,NULL,NULL,
  NULL,NULL,NULL,0x160E,NULL },
{ &gadget6[16],194,21,9,9,GADGHNONE,GADGIMMEDIATE,BOOLGADGET,NULL,NULL,
  NULL,NULL,NULL,0x160F,NULL },
{ &gadget6[17],205,21,9,9,GADGHNONE,GADGIMMEDIATE,BOOLGADGET,NULL,NULL,
  NULL,NULL,NULL,0x1610,NULL },
{ &gadget6[18],216,21,9,9,GADGHNONE,GADGIMMEDIATE,BOOLGADGET,NULL,NULL,
  NULL,NULL,NULL,0x1611,NULL },
{ &gadget6[19],63,50,15,9,GADGHNONE,GADGIMMEDIATE,BOOLGADGET,NULL,NULL,
  NULL,NULL,NULL,0x1612,NULL }, /* Okt 1+2 */
{ &gadget6[20],80,50,15,9,GADGHNONE,GADGIMMEDIATE,BOOLGADGET,NULL,NULL,
  NULL,NULL,NULL,0x613,NULL }, /* Okt 2+3 */
{ &gadget6[21],97,50,15,9,GADGHNONE,GADGIMMEDIATE,BOOLGADGET,NULL,NULL,
  NULL,NULL,NULL,0x614,NULL }, /* Okt 3+4 */
{ &gadget6[23],114,50,15,9,GADGHNONE,GADGIMMEDIATE,BOOLGADGET,NULL,NULL,
  NULL,NULL,NULL,0x615,NULL }, /* Okt 4+5 */
{ NULL,131,50,15,9,GADGHNONE,GADGIMMEDIATE,BOOLGADGET,NULL,NULL,
  NULL,NULL,NULL,0x616,NULL }, /* ??? (Empty) */
{ &gadget6[24],9,40,8,8,GADGHNONE,GADGIMMEDIATE,BOOLGADGET,NULL,NULL,
  NULL,NULL,NULL,0x617,NULL }, /* <- */
{ &gadget6[25],29,40,8,8,GADGHNONE,GADGIMMEDIATE,BOOLGADGET,NULL,NULL,
  NULL,NULL,NULL,0x618,NULL }, /* -> */
{ &gadget6[26],63,41,49,7,GADGHNONE,GADGIMMEDIATE,BOOLGADGET,NULL,NULL,
  NULL,NULL,NULL,0x1619,NULL }, /* autom. rivinv. */
{ &gadget6[27],79,32,15,7,GADGHNONE,GADGIMMEDIATE,BOOLGADGET,NULL,NULL,
  NULL,NULL,NULL,0x61A,NULL }, /* v.fx */
{ &gadget6[28],96,32,16,7,GADGHNONE,GADGIMMEDIATE,BOOLGADGET,NULL,NULL,
  NULL,NULL,NULL,0x61B,NULL }, /* o.fx */
{ NULL,39,40,13,7,GADGHNONE,GADGIMMEDIATE,BOOLGADGET,NULL,NULL,
  NULL,NULL,NULL,0x61C,NULL } /* ota pikanuotti */
};

struct Gadget far gadget7[] = {
{ &gadget7[1],15,21,90,8,GADGHCOMP|GADGIMAGE,RELVERIFY,PROPGADGET,
  (APTR)&autoknobimg[5],NULL,NULL,NULL,(APTR)&propinfo[5],0x700,NULL },
{ &gadget7[2],15,31,90,8,GADGHCOMP|GADGIMAGE,RELVERIFY,PROPGADGET,
  (APTR)&autoknobimg[6],NULL,NULL,NULL,(APTR)&propinfo[6],0x701,NULL },
{ &gadget7[3],15,41,90,8,GADGHCOMP|GADGIMAGE,RELVERIFY,PROPGADGET,
  (APTR)&autoknobimg[7],NULL,NULL,NULL,(APTR)&propinfo[7],0x702,NULL },
{ &gadget7[4],15,52,8,8,GADGHNONE,GADGIMMEDIATE,BOOLGADGET,NULL,NULL,
  NULL,NULL,NULL,0x703,NULL },	/* vri 0 */
{ &gadget7[5],25,52,8,8,GADGHNONE,GADGIMMEDIATE,BOOLGADGET,NULL,NULL,
  NULL,NULL,NULL,0x704,NULL },
{ &gadget7[6],35,52,8,8,GADGHNONE,GADGIMMEDIATE,BOOLGADGET,NULL,NULL,
  NULL,NULL,NULL,0x705,NULL },
{ &gadget7[7],45,52,8,8,GADGHNONE,GADGIMMEDIATE,BOOLGADGET,NULL,NULL,
  NULL,NULL,NULL,0x706,NULL },
{ &gadget7[8],55,52,8,8,GADGHNONE,GADGIMMEDIATE,BOOLGADGET,NULL,NULL,
  NULL,NULL,NULL,0x707,NULL },
{ &gadget7[9],65,52,8,8,GADGHNONE,GADGIMMEDIATE,BOOLGADGET,NULL,NULL,
  NULL,NULL,NULL,0x708,NULL },
{ &gadget7[10],75,52,8,8,GADGHNONE,GADGIMMEDIATE,BOOLGADGET,NULL,NULL,
  NULL,NULL,NULL,0x709,NULL },
{ &gadget7[11],85,52,8,8,GADGHNONE,GADGIMMEDIATE,BOOLGADGET,NULL,NULL,
  NULL,NULL,NULL,0x70A,NULL },	/* vri 7 */
{ &gadget7[12],118,21,27,7,GADGHNONE,GADGIMMEDIATE,BOOLGADGET,NULL,NULL,
  NULL,NULL,NULL,0x70B,NULL },	/* nollaa */
{ &gadget7[13],118,31,27,7,GADGHNONE,GADGIMMEDIATE,BOOLGADGET,NULL,NULL,
  NULL,NULL,NULL,0x70C,NULL },	/* peru */
{ &gadget7[14],150,53,23,7,GADGHNONE,GADGIMMEDIATE,BOOLGADGET,NULL,NULL,
  NULL,NULL,NULL,0x70D,NULL },	/* ei hypi */
{ &gadget7[15],175,53,26,7,GADGHNONE,GADGIMMEDIATE,BOOLGADGET,NULL,NULL,
  NULL,NULL,NULL,0x70E,NULL },	/* joka 8. */
{ &gadget7[16],203,53,24,7,GADGHNONE,GADGIMMEDIATE,BOOLGADGET,NULL,NULL,
  NULL,NULL,NULL,0x170F,NULL },	/* soitin */
{ &gadget7[17],171,19,57,7,GADGHNONE,GADGIMMEDIATE,BOOLGADGET,NULL,NULL,
  NULL,NULL,NULL,0x711,NULL },	/* uusi kpl */
{ &gadget7[18],171,28,57,7,GADGHNONE,GADGIMMEDIATE,BOOLGADGET,NULL,NULL,
  NULL,NULL,NULL,0x712,NULL },	/* jt soittimet */
{ &gadget7[19],171,37,57,7,GADGHNONE,GADGIMMEDIATE,BOOLGADGET,NULL,NULL,
  NULL,NULL,NULL,0x713,NULL },	/* poistu */
{ NULL,159,19,10,12,GADGHNONE,GADGIMMEDIATE,BOOLGADGET,NULL,NULL,
  NULL,NULL,NULL,0x714,NULL }	/* OK! */
};

struct Gadget far gadget9[] = {
{ &gadget9[1],8,53,41,7,GADGHNONE,GADGIMMEDIATE,BOOLGADGET,NULL,NULL,
  NULL,NULL,NULL,0x900,NULL },	/* MIDI pll */
{ &gadget9[2],24,34,21,7,GADGHNONE,GADGIMMEDIATE,BOOLGADGET,NULL,NULL,
  NULL,NULL,NULL,0x901,NULL },	/* Midi kyll */
{ &gadget9[3],47,34,7,7,GADGHNONE,GADGIMMEDIATE,BOOLGADGET,NULL,NULL,
  NULL,NULL,NULL,0x1902,NULL },	/* Midi ei */
{ &gadget9[4],117,26,5,7,GADGHNONE,GADGIMMEDIATE,BOOLGADGET,NULL,NULL,
  NULL,NULL,NULL,0x903,NULL },	/* 1 */
{ &gadget9[5],124,26,5,7,GADGHNONE,GADGIMMEDIATE,BOOLGADGET,NULL,NULL,
  NULL,NULL,NULL,0x904,NULL },	/* 2 */
{ &gadget9[6],131,26,5,7,GADGHNONE,GADGIMMEDIATE,BOOLGADGET,NULL,NULL,
  NULL,NULL,NULL,0x905,NULL },	/* 3 */
{ &gadget9[7],138,26,5,7,GADGHNONE,GADGIMMEDIATE,BOOLGADGET,NULL,NULL,
  NULL,NULL,NULL,0x906,NULL },	/* 4 */
{ &gadget9[8],145,26,5,7,GADGHNONE,GADGIMMEDIATE,BOOLGADGET,NULL,NULL,
  NULL,NULL,NULL,0x907,NULL },	/* 5 */
{ &gadget9[9],152,26,5,7,GADGHNONE,GADGIMMEDIATE,BOOLGADGET,NULL,NULL,
  NULL,NULL,NULL,0x908,NULL },	/* 6 */
{ &gadget9[10],159,26,5,7,GADGHNONE,GADGIMMEDIATE,BOOLGADGET,NULL,NULL,
  NULL,NULL,NULL,0x909,NULL },	/* 7 */
{ &gadget9[11],166,26,5,7,GADGHNONE,GADGIMMEDIATE,BOOLGADGET,NULL,NULL,
  NULL,NULL,NULL,0x90A,NULL },	/* 8 */
{ &gadget9[12],173,26,5,7,GADGHNONE,GADGIMMEDIATE,BOOLGADGET,NULL,NULL,
  NULL,NULL,NULL,0x90B,NULL },	/* 9 */
{ &gadget9[13],180,26,5,7,GADGHNONE,GADGIMMEDIATE,BOOLGADGET,NULL,NULL,
  NULL,NULL,NULL,0x90C,NULL },	/* 10 */
{ &gadget9[14],187,26,5,7,GADGHNONE,GADGIMMEDIATE,BOOLGADGET,NULL,NULL,
  NULL,NULL,NULL,0x90D,NULL },	/* 11 */
{ &gadget9[15],194,26,5,7,GADGHNONE,GADGIMMEDIATE,BOOLGADGET,NULL,NULL,
  NULL,NULL,NULL,0x90E,NULL },	/* 12 */
{ &gadget9[16],201,26,5,7,GADGHNONE,GADGIMMEDIATE,BOOLGADGET,NULL,NULL,
  NULL,NULL,NULL,0x90F,NULL },	/* 13 */
{ &gadget9[17],208,26,5,7,GADGHNONE,GADGIMMEDIATE,BOOLGADGET,NULL,NULL,
  NULL,NULL,NULL,0x910,NULL },	/* 14 */
{ &gadget9[18],215,26,5,7,GADGHNONE,GADGIMMEDIATE,BOOLGADGET,NULL,NULL,
  NULL,NULL,NULL,0x911,NULL },	/* 15 */
{ &gadget9[19],222,26,5,7,GADGHNONE,GADGIMMEDIATE,BOOLGADGET,NULL,NULL,
  NULL,NULL,NULL,0x912,NULL },	/* 16 */
{ &gadget9[20],117,44,24,8,GADGHCOMP,RELVERIFY|LONGINT,STRGADGET,NULL,NULL,
  NULL,NULL,(APTR)&strinfo[5],0x913,NULL },	/* Preset # str */
{ &gadget9[21],144,45,6,6,GADGHNONE,GADGIMMEDIATE,BOOLGADGET,NULL,NULL,
  NULL,NULL,NULL,0x914,NULL },	/* <-     v- Preset # prop*/
{ &gadget9[22],154,45,62,6,GADGHCOMP|GADGIMAGE,RELVERIFY,PROPGADGET,
  (APTR)&autoknobimg[3],NULL,NULL,NULL,(APTR)&propinfo[3],0x915,NULL },
{ &gadget9[23],220,45,6,6,GADGHNONE,GADGIMMEDIATE,BOOLGADGET,NULL,NULL,
  NULL,NULL,NULL,0x916,NULL },	/* -> */
{ NULL,51,53,53,7,GADGHNONE,GADGIMMEDIATE,BOOLGADGET,NULL,NULL,
  NULL,NULL,NULL,0x917,NULL }	/* Sytt */
};
  
struct Gadget far gadgetA[] = {
{ &gadgetA[1],6,26,40,7,GADGHNONE,GADGIMMEDIATE,BOOLGADGET,NULL,NULL,
  NULL,NULL,NULL,0xA00,NULL },
{ &gadgetA[2],6,35,40,7,GADGHNONE,GADGIMMEDIATE,BOOLGADGET,NULL,NULL,
  NULL,NULL,NULL,0xA01,NULL },
{ &gadgetA[3],6,44,40,7,GADGHNONE,GADGIMMEDIATE,BOOLGADGET,NULL,NULL,
  NULL,NULL,NULL,0xA02,NULL },
{ &gadgetA[4],6,53,40,7,GADGHNONE,GADGIMMEDIATE,BOOLGADGET,NULL,NULL,
  NULL,NULL,NULL,0xA03,NULL },
{ &gadgetA[5],59,26,40,7,GADGHNONE,GADGIMMEDIATE,BOOLGADGET,NULL,NULL,
  NULL,NULL,NULL,0xA04,NULL },
{ &gadgetA[6],59,35,40,7,GADGHNONE,GADGIMMEDIATE,BOOLGADGET,NULL,NULL,
  NULL,NULL,NULL,0xA05,NULL },
{ &gadgetA[7],59,44,40,7,GADGHNONE,GADGIMMEDIATE,BOOLGADGET,NULL,NULL,
  NULL,NULL,NULL,0xA06,NULL },
{ &gadgetA[8],59,53,40,7,GADGHNONE,GADGIMMEDIATE,BOOLGADGET,NULL,NULL,
  NULL,NULL,NULL,0xA07,NULL },
{ &gadgetA[9],112,26,40,7,GADGHNONE,GADGIMMEDIATE,BOOLGADGET,NULL,NULL,
  NULL,NULL,NULL,0xA08,NULL },
{ &gadgetA[10],112,35,40,7,GADGHNONE,GADGIMMEDIATE,BOOLGADGET,NULL,NULL,
  NULL,NULL,NULL,0xA09,NULL },
{ &gadgetA[11],112,44,40,7,GADGHNONE,GADGIMMEDIATE,BOOLGADGET,NULL,NULL,
  NULL,NULL,NULL,0xA0A,NULL },
{ &gadgetA[12],112,53,40,7,GADGHNONE,GADGIMMEDIATE,BOOLGADGET,NULL,NULL,
  NULL,NULL,NULL,0xA0B,NULL },
{ &gadgetA[13],156,26,5,6,GADGHNONE,GADGIMMEDIATE,BOOLGADGET,NULL,NULL,
  NULL,NULL,NULL,0xA0C,NULL },	/* Soiton transp.: - */
{ &gadgetA[14],163,26,57,6,GADGHCOMP|GADGIMAGE,RELVERIFY,PROPGADGET,
  (APTR)&autoknobimg[4],NULL,NULL,NULL,(APTR)&propinfo[4],0xA0D,NULL },
{ &gadgetA[15],222,26,5,6,GADGHNONE,GADGIMMEDIATE,BOOLGADGET,NULL,NULL,
  NULL,NULL,NULL,0xA0E,NULL },	/* transp.: + */
{ &gadgetA[16],155,44,37,7,GADGHNONE,GADGIMMEDIATE,BOOLGADGET,NULL,NULL,
  NULL,NULL,NULL,0xA0F,NULL },
{ &gadgetA[17],194,44,33,7,GADGHNONE,GADGIMMEDIATE,BOOLGADGET,NULL,NULL,
  NULL,NULL,NULL,0xA10,NULL },
{ &gadgetA[18],168,53,21,7,GADGHNONE,GADGIMMEDIATE,BOOLGADGET,NULL,NULL,
  NULL,NULL,NULL,0x1A11,NULL },
{ NULL,191,53,36,7,GADGHNONE,GADGIMMEDIATE,BOOLGADGET,NULL,NULL,
  NULL,NULL,NULL,0xA12,NULL }
};

struct Gadget far *glists[] = { NULL,gadget1,gadget2,gadget3,gadget4,
	gadget5,gadget6,gadget7,NULL,gadget9,gadgetA,NULL };
extern char title[]; /* med-rev.c:ss */
struct TextAttr far nsfont = { "topaz.font",8,0,0 };
struct NewScreen far ns = { 0,0,320,STDSCREENHEIGHT,3,0,1,0,CUSTOMSCREEN,
	&nsfont,title,NULL,NULL };
struct NewWindow far nw = { 0,0,320,200,-1,-1,GADGETDOWN|RAWKEY|GADGETUP|MOUSEBUTTONS,
	SMART_REFRESH|BACKDROP|BORDERLESS|ACTIVATE|NOCAREREFRESH|RMBTRAP,
	&gadget1[0],NULL,NULL,NULL,NULL,0,0,0,0,CUSTOMSCREEN };
struct NewWindow far pnw = { 0,16,320,56,-1,-1,NULL,NOCAREREFRESH|
	SMART_REFRESH|BORDERLESS|RMBTRAP,NULL,NULL,NULL,NULL,NULL,0,0,0,0,
	CUSTOMSCREEN }; /* eqalizerikkuna - kytss vain NTSC-Amigoissa */
